## telegram-desktop 3.1.1+ds-1~bpo10+1+10.0trisquel2

=== Telegram/CMakeLists.txt ===
# This file is part of Telegram Desktop,
# the official desktop application for the Telegram messaging service.
#
# For license and copyright information please follow this link:
# https://github.com/telegramdesktop/tdesktop/blob/master/LEGAL

add_executable(Telegram WIN32 MACOSX_BUNDLE)
init_target(Telegram)

add_subdirectory(lib_rpl)
add_subdirectory(lib_crl)
add_subdirectory(lib_base)
add_subdirectory(lib_ui)
add_subdirectory(lib_tl)
if (NOT DESKTOP_APP_DISABLE_SPELLCHECK)
    add_subdirectory(lib_spellcheck)
endif()
add_subdirectory(lib_storage)
add_subdirectory(lib_lottie)
add_subdirectory(lib_qr)
add_subdirectory(lib_webrtc)
add_subdirectory(lib_webview)
add_subdirectory(codegen)

get_filename_component(src_loc SourceFiles REALPATH)
get_filename_component(res_loc Resources REALPATH)

include(cmake/telegram_options.cmake)
include(cmake/lib_ffmpeg.cmake)
include(cmake/lib_stripe.cmake)
include(cmake/lib_tgvoip.cmake)
include(cmake/lib_tgcalls.cmake)
include(cmake/td_export.cmake)
include(cmake/td_mtproto.cmake)
include(cmake/td_lang.cmake)
include(cmake/td_scheme.cmake)
include(cmake/td_ui.cmake)
include(cmake/generate_appdata_changelog.cmake)

if (WIN32)
    include(cmake/generate_midl.cmake)
    generate_midl(Telegram ${src_loc}/platform/win/windows_quiethours.idl)
endif()

set_target_properties(Telegram PROPERTIES AUTOMOC ON)
if (TDESKTOP_RESOURCES STREQUAL "Bundled")
    set_target_properties(Telegram PROPERTIES AUTORCC ON)
elseif (TDESKTOP_RESOURCES STREQUAL "Packed")
    set(rcc_flags --binary "$<TARGET_PROPERTY:Telegram,AUTORCC_OPTIONS>")
    set(qrc_files "$<FILTER:$<TARGET_PROPERTY:Telegram,SOURCES>,INCLUDE,\\.qrc$>")
    target_compile_definitions(Telegram PRIVATE TDESKTOP_USE_PACKED_RESOURCES)
    target_sources(Telegram PRIVATE "${CMAKE_BINARY_DIR}/tresources.rcc")
    add_custom_command(OUTPUT "${CMAKE_BINARY_DIR}/tresources.rcc"
        DEPENDS ${qrc_files}  # FIXME: incomplete dependencies list, missing qrc content
        COMMAND Qt5::rcc ${rcc_flags} -o "${CMAKE_BINARY_DIR}/tresources.rcc" ${qrc_files}
        COMMAND_EXPAND_LISTS VERBATIM
    )
    set_target_properties(Telegram PROPERTIES RESOURCE "${CMAKE_BINARY_DIR}/tresources.rcc")
endif()

target_link_libraries(Telegram
PRIVATE
    tdesktop::lib_tgcalls_legacy
    tdesktop::lib_tgcalls
    tdesktop::lib_tgvoip

    # Order in this list defines the order of include paths in command line.
    # We need to place desktop-app::external_minizip this early to have its
    # include paths (usually ${PREFIX}/include/minizip) before any depend that
    # would add ${PREFIX}/include. This path may have a different <zip.h>,
    # for example installed by libzip (https://libzip.org).
    desktop-app::external_minizip

    tdesktop::td_export
    tdesktop::td_mtproto
    tdesktop::td_lang
    tdesktop::td_scheme
    tdesktop::td_ui
    desktop-app::lib_webrtc
    desktop-app::lib_base
    desktop-app::lib_crl
    desktop-app::lib_ui
    desktop-app::lib_tl
    desktop-app::lib_storage
    desktop-app::lib_lottie
    desktop-app::lib_qr
    desktop-app::lib_webview
    desktop-app::lib_ffmpeg
    desktop-app::lib_stripe
    desktop-app::external_lz4
    desktop-app::external_rlottie
    desktop-app::external_zlib
    desktop-app::external_qt_static_plugins
    desktop-app::external_qt
    desktop-app::external_qr_code_generator
    desktop-app::external_crash_reports
    desktop-app::external_auto_updates
    desktop-app::external_openssl
    desktop-app::external_openal
    desktop-app::external_xxhash
)

target_precompile_headers(Telegram PRIVATE ${src_loc}/stdafx.h)
nice_target_sources(Telegram ${src_loc}
PRIVATE
    ${style_files}

    api/api_attached_stickers.cpp
    api/api_attached_stickers.h
    api/api_authorizations.cpp
    api/api_authorizations.h
    api/api_blocked_peers.cpp
    api/api_blocked_peers.h
    api/api_bot.cpp
    api/api_bot.h
    api/api_chat_filters.cpp
    api/api_chat_filters.h
    api/api_chat_invite.cpp
    api/api_chat_invite.h
    api/api_cloud_password.cpp
    api/api_cloud_password.h
    api/api_common.h
    api/api_editing.cpp
    api/api_editing.h
    api/api_global_privacy.cpp
    api/api_global_privacy.h
    api/api_hash.cpp
    api/api_hash.h
    api/api_invite_links.cpp
    api/api_invite_links.h
    api/api_media.cpp
    api/api_media.h
    api/api_self_destruct.cpp
    api/api_self_destruct.h
    api/api_send_progress.cpp
    api/api_send_progress.h
    api/api_sending.cpp
    api/api_sending.h
    api/api_sensitive_content.cpp
    api/api_sensitive_content.h
    api/api_single_message_search.cpp
    api/api_single_message_search.h
    api/api_text_entities.cpp
    api/api_text_entities.h
    api/api_toggling_media.cpp
    api/api_toggling_media.h
    api/api_updates.cpp
    api/api_updates.h
    api/api_user_privacy.cpp
    api/api_user_privacy.h
    api/api_who_read.cpp
    api/api_who_read.h
    boxes/filters/edit_filter_box.cpp
    boxes/filters/edit_filter_box.h
    boxes/filters/edit_filter_chats_list.cpp
    boxes/filters/edit_filter_chats_list.h
    boxes/peers/add_participants_box.cpp
    boxes/peers/add_participants_box.h
    boxes/peers/edit_contact_box.cpp
    boxes/peers/edit_contact_box.h
    boxes/peers/edit_linked_chat_box.cpp
    boxes/peers/edit_linked_chat_box.h
    boxes/peers/edit_participant_box.cpp
    boxes/peers/edit_participant_box.h
    boxes/peers/edit_participants_box.cpp
    boxes/peers/edit_participants_box.h
    boxes/peers/edit_peer_info_box.cpp
    boxes/peers/edit_peer_info_box.h
    boxes/peers/edit_peer_invite_link.cpp
    boxes/peers/edit_peer_invite_link.h
    boxes/peers/edit_peer_invite_links.cpp
    boxes/peers/edit_peer_invite_links.h
    boxes/peers/edit_peer_type_box.cpp
    boxes/peers/edit_peer_type_box.h
    boxes/peers/edit_peer_history_visibility_box.cpp
    boxes/peers/edit_peer_history_visibility_box.h
    boxes/peers/edit_peer_permissions_box.cpp
    boxes/peers/edit_peer_permissions_box.h
    boxes/about_box.cpp
    boxes/about_box.h
    boxes/abstract_box.cpp
    boxes/abstract_box.h
    boxes/add_contact_box.cpp
    boxes/add_contact_box.h
    boxes/auto_lock_box.cpp
    boxes/auto_lock_box.h
    boxes/auto_download_box.cpp
    boxes/auto_download_box.h
    boxes/background_box.cpp
    boxes/background_box.h
    boxes/background_preview_box.cpp
    boxes/background_preview_box.h
    boxes/change_phone_box.cpp
    boxes/change_phone_box.h
    boxes/confirm_box.cpp
    boxes/confirm_box.h
    boxes/confirm_phone_box.cpp
    boxes/confirm_phone_box.h
    boxes/connection_box.cpp
    boxes/connection_box.h
    boxes/create_poll_box.cpp
    boxes/create_poll_box.h
    boxes/dictionaries_manager.cpp
    boxes/dictionaries_manager.h
    boxes/download_path_box.cpp
    boxes/download_path_box.h
    boxes/edit_caption_box.cpp
    boxes/edit_caption_box.h
    boxes/edit_color_box.cpp
    boxes/edit_color_box.h
    boxes/edit_privacy_box.cpp
    boxes/edit_privacy_box.h
    boxes/language_box.cpp
    boxes/language_box.h
    boxes/local_storage_box.cpp
    boxes/local_storage_box.h
    boxes/mute_settings_box.cpp
    boxes/mute_settings_box.h
    boxes/peer_list_box.cpp
    boxes/peer_list_box.h
    boxes/peer_list_controllers.cpp
    boxes/peer_list_controllers.h
    boxes/peer_lists_box.cpp
    boxes/peer_lists_box.h
    boxes/passcode_box.cpp
    boxes/passcode_box.h
    boxes/rate_call_box.cpp
    boxes/rate_call_box.h
    boxes/self_destruction_box.cpp
    boxes/self_destruction_box.h
    boxes/send_files_box.cpp
    boxes/send_files_box.h
    boxes/sessions_box.cpp
    boxes/sessions_box.h
    boxes/share_box.cpp
    boxes/share_box.h
    boxes/sticker_set_box.cpp
    boxes/sticker_set_box.h
    boxes/stickers_box.cpp
    boxes/stickers_box.h
    boxes/url_auth_box.cpp
    boxes/url_auth_box.h
    boxes/username_box.cpp
    boxes/username_box.h
    calls/group/calls_choose_join_as.cpp
    calls/group/calls_choose_join_as.h
    calls/group/calls_group_call.cpp
    calls/group/calls_group_call.h
    calls/group/calls_group_common.cpp
    calls/group/calls_group_common.h
    calls/group/calls_group_invite_controller.cpp
    calls/group/calls_group_invite_controller.h
    calls/group/calls_group_members.cpp
    calls/group/calls_group_members.h
    calls/group/calls_group_members_row.cpp
    calls/group/calls_group_members_row.h
    calls/group/calls_group_menu.cpp
    calls/group/calls_group_menu.h
    calls/group/calls_group_panel.cpp
    calls/group/calls_group_panel.h
    calls/group/calls_group_settings.cpp
    calls/group/calls_group_settings.h
    calls/group/calls_group_toasts.cpp
    calls/group/calls_group_toasts.h
    calls/group/calls_group_viewport.cpp
    calls/group/calls_group_viewport.h
    calls/group/calls_group_viewport_opengl.cpp
    calls/group/calls_group_viewport_opengl.h
    calls/group/calls_group_viewport_raster.cpp
    calls/group/calls_group_viewport_raster.h
    calls/group/calls_group_viewport_tile.cpp
    calls/group/calls_group_viewport_tile.h
    calls/group/calls_volume_item.cpp
    calls/group/calls_volume_item.h
    calls/calls_box_controller.cpp
    calls/calls_box_controller.h
    calls/calls_call.cpp
    calls/calls_call.h
    calls/calls_emoji_fingerprint.cpp
    calls/calls_emoji_fingerprint.h
    calls/calls_instance.cpp
    calls/calls_instance.h
    calls/calls_panel.cpp
    calls/calls_panel.h
    calls/calls_signal_bars.cpp
    calls/calls_signal_bars.h
    calls/calls_top_bar.cpp
    calls/calls_top_bar.h
    calls/calls_userpic.cpp
    calls/calls_userpic.h
    calls/calls_video_bubble.cpp
    calls/calls_video_bubble.h
    calls/calls_video_incoming.cpp
    calls/calls_video_incoming.h
    chat_helpers/bot_command.cpp
    chat_helpers/bot_command.h
    chat_helpers/bot_keyboard.cpp
    chat_helpers/bot_keyboard.h
    chat_helpers/emoji_interactions.cpp
    chat_helpers/emoji_interactions.h
    chat_helpers/emoji_keywords.cpp
    chat_helpers/emoji_keywords.h
    chat_helpers/emoji_list_widget.cpp
    chat_helpers/emoji_list_widget.h
    chat_helpers/emoji_sets_manager.cpp
    chat_helpers/emoji_sets_manager.h
    chat_helpers/emoji_suggestions_widget.cpp
    chat_helpers/emoji_suggestions_widget.h
    chat_helpers/field_autocomplete.cpp
    chat_helpers/field_autocomplete.h
    chat_helpers/gifs_list_widget.cpp
    chat_helpers/gifs_list_widget.h
    chat_helpers/message_field.cpp
    chat_helpers/message_field.h
    chat_helpers/send_context_menu.cpp
    chat_helpers/send_context_menu.h
    chat_helpers/spellchecker_common.cpp
    chat_helpers/spellchecker_common.h
    chat_helpers/stickers_emoji_image_loader.cpp
    chat_helpers/stickers_emoji_image_loader.h
    chat_helpers/stickers_emoji_pack.cpp
    chat_helpers/stickers_emoji_pack.h
    chat_helpers/stickers_dice_pack.cpp
    chat_helpers/stickers_dice_pack.h
    chat_helpers/stickers_list_widget.cpp
    chat_helpers/stickers_list_widget.h
    chat_helpers/stickers_lottie.cpp
    chat_helpers/stickers_lottie.h
    chat_helpers/tabbed_panel.cpp
    chat_helpers/tabbed_panel.h
    chat_helpers/tabbed_section.cpp
    chat_helpers/tabbed_section.h
    chat_helpers/tabbed_selector.cpp
    chat_helpers/tabbed_selector.h
    core/application.cpp
    core/application.h
    core/base_integration.cpp
    core/base_integration.h
    core/changelogs.cpp
    core/changelogs.h
    core/click_handler_types.cpp
    core/click_handler_types.h
    core/core_cloud_password.cpp
    core/core_cloud_password.h
    core/core_settings.cpp
    core/core_settings.h
    core/core_settings_proxy.cpp
    core/core_settings_proxy.h
    core/crash_report_window.cpp
    core/crash_report_window.h
    core/crash_reports.cpp
    core/crash_reports.h
    core/file_utilities.cpp
    core/file_utilities.h
    core/launcher.cpp
    core/launcher.h
    core/local_url_handlers.cpp
    core/local_url_handlers.h
    core/sandbox.cpp
    core/sandbox.h
    core/shortcuts.cpp
    core/shortcuts.h
    core/ui_integration.cpp
    core/ui_integration.h

=== Telegram/lib_ui/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(lib_ui STATIC)
add_library(desktop-app::lib_ui ALIAS lib_ui)
init_target(lib_ui)

include(cmake/generate_palette.cmake)
include(cmake/generate_styles.cmake)
include(cmake/generate_emoji.cmake)

get_filename_component(src_loc . REALPATH)

set(style_files
    ui/basic.style
    ui/layers/layers.style
    ui/widgets/widgets.style
)

generate_palette(lib_ui ui/colors.palette)
generate_styles(lib_ui ${src_loc} "${style_files}" ui/colors.palette)
generate_emoji(lib_ui emoji.txt emoji_suggestions/emoji_autocomplete.json)

set_target_properties(lib_ui PROPERTIES AUTOMOC ON AUTORCC ON)

target_precompile_headers(lib_ui PRIVATE ${src_loc}/ui/ui_pch.h)
nice_target_sources(lib_ui ${src_loc}
PRIVATE
    ${style_files}
    ui/colors.palette
    emoji_suggestions/emoji_autocomplete.json

    qt_conf/mac.qrc
    qt_conf/win.qrc

    ui/effects/animation_value.cpp
    ui/effects/animation_value.h
    ui/effects/animations.cpp
    ui/effects/animations.h
    ui/effects/cross_animation.cpp
    ui/effects/cross_animation.h
    ui/effects/cross_line.cpp
    ui/effects/cross_line.h
    ui/effects/fade_animation.cpp
    ui/effects/fade_animation.h
    ui/effects/gradient.h
    ui/effects/numbers_animation.cpp
    ui/effects/numbers_animation.h
    ui/effects/panel_animation.cpp
    ui/effects/panel_animation.h
    ui/effects/path_shift_gradient.cpp
    ui/effects/path_shift_gradient.h
    ui/effects/radial_animation.cpp
    ui/effects/radial_animation.h
    ui/effects/ripple_animation.cpp
    ui/effects/ripple_animation.h
    ui/effects/slide_animation.cpp
    ui/effects/slide_animation.h
    ui/gl/gl_detection.cpp
    ui/gl/gl_detection.h
    ui/gl/gl_image.cpp
    ui/gl/gl_image.h
    ui/gl/gl_math.cpp
    ui/gl/gl_math.h
    ui/gl/gl_primitives.cpp
    ui/gl/gl_primitives.h
    ui/gl/gl_shader.cpp
    ui/gl/gl_shader.h
    ui/gl/gl_surface.cpp
    ui/gl/gl_surface.h
    ui/gl/gl_window.cpp
    ui/gl/gl_window.h
    ui/image/image_prepare.cpp
    ui/image/image_prepare.h
    ui/layers/box_content.cpp
    ui/layers/box_content.h
    ui/layers/box_layer_widget.cpp
    ui/layers/box_layer_widget.h
    ui/layers/generic_box.cpp
    ui/layers/generic_box.h
    ui/layers/layer_manager.cpp
    ui/layers/layer_manager.h
    ui/layers/layer_widget.cpp
    ui/layers/layer_widget.h
    ui/paint/arcs.cpp
    ui/paint/arcs.h
    ui/paint/blob.cpp
    ui/paint/blob.h
    ui/paint/blobs.cpp
    ui/paint/blobs.h
    ui/paint/blobs_linear.cpp
    ui/paint/blobs_linear.h
    ui/platform/linux/ui_linux_wayland_integration.cpp
    ui/platform/linux/ui_linux_wayland_integration.h
    ui/platform/linux/ui_window_linux.cpp
    ui/platform/linux/ui_window_linux.h
    ui/platform/linux/ui_utility_linux.cpp
    ui/platform/linux/ui_utility_linux.h
    ui/platform/mac/ui_window_mac.h
    ui/platform/mac/ui_window_mac.mm
    ui/platform/mac/ui_window_title_mac.h
    ui/platform/mac/ui_window_title_mac.mm
    ui/platform/mac/ui_utility_mac.h
    ui/platform/mac/ui_utility_mac.mm
    ui/platform/win/ui_window_shadow_win.cpp
    ui/platform/win/ui_window_shadow_win.h
    ui/platform/win/ui_window_title_win.cpp
    ui/platform/win/ui_window_title_win.h
    ui/platform/win/ui_window_win.cpp
    ui/platform/win/ui_window_win.h
    ui/platform/win/ui_utility_win.cpp
    ui/platform/win/ui_utility_win.h
    ui/platform/ui_platform_window_title.cpp
    ui/platform/ui_platform_window_title.h
    ui/platform/ui_platform_window.cpp
    ui/platform/ui_platform_window.h
    ui/platform/ui_platform_utility.cpp
    ui/platform/ui_platform_utility.h
    ui/style/style_core.cpp
    ui/style/style_core.h
    ui/style/style_core_color.cpp
    ui/style/style_core_color.h
    ui/style/style_core_custom_font.cpp
    ui/style/style_core_custom_font.h
    ui/style/style_core_direction.cpp
    ui/style/style_core_direction.h
    ui/style/style_core_font.cpp
    ui/style/style_core_font.h
    ui/style/style_core_icon.cpp
    ui/style/style_core_icon.h
    ui/style/style_core_palette.cpp
    ui/style/style_core_palette.h
    ui/style/style_core_scale.cpp
    ui/style/style_core_scale.h
    ui/style/style_core_types.cpp
    ui/style/style_core_types.h
    ui/style/style_palette_colorizer.cpp
    ui/style/style_palette_colorizer.h
    ui/text/text.cpp
    ui/text/text.h
    ui/text/text_block.cpp
    ui/text/text_block.h
    ui/text/text_entity.cpp
    ui/text/text_entity.h
    ui/text/text_isolated_emoji.h
    ui/text/text_utilities.cpp
    ui/text/text_utilities.h
    ui/toast/toast.cpp
    ui/toast/toast.h
    ui/toast/toast_manager.cpp
    ui/toast/toast_manager.h
    ui/toast/toast_widget.cpp
    ui/toast/toast_widget.h
    ui/widgets/box_content_divider.cpp
    ui/widgets/box_content_divider.h
    ui/widgets/buttons.cpp
    ui/widgets/buttons.h
    ui/widgets/call_button.cpp
    ui/widgets/call_button.h
    ui/widgets/checkbox.cpp
    ui/widgets/checkbox.h
    ui/widgets/dropdown_menu.cpp
    ui/widgets/dropdown_menu.h
    ui/widgets/inner_dropdown.cpp
    ui/widgets/inner_dropdown.h
    ui/widgets/input_fields.cpp
    ui/widgets/input_fields.h
    ui/widgets/labels.cpp
    ui/widgets/labels.h
    ui/widgets/menu/menu.cpp
    ui/widgets/menu/menu.h
    ui/widgets/menu/menu_action.cpp
    ui/widgets/menu/menu_action.h
    ui/widgets/menu/menu_common.cpp
    ui/widgets/menu/menu_common.h
    ui/widgets/menu/menu_item_base.cpp
    ui/widgets/menu/menu_item_base.h
    ui/widgets/menu/menu_separator.cpp
    ui/widgets/menu/menu_separator.h
    ui/widgets/menu/menu_toggle.cpp
    ui/widgets/menu/menu_toggle.h
    ui/widgets/popup_menu.cpp
    ui/widgets/popup_menu.h
    ui/widgets/rp_window.cpp
    ui/widgets/rp_window.h
    ui/widgets/scroll_area.cpp
    ui/widgets/scroll_area.h
    ui/widgets/side_bar_button.cpp
    ui/widgets/side_bar_button.h
    ui/widgets/shadow.cpp
    ui/widgets/shadow.h
    ui/widgets/time_input.cpp
    ui/widgets/time_input.h
    ui/widgets/tooltip.cpp
    ui/widgets/tooltip.h
    ui/wrap/fade_wrap.cpp
    ui/wrap/fade_wrap.h
    ui/wrap/padding_wrap.cpp
    ui/wrap/padding_wrap.h
    ui/wrap/slide_wrap.cpp
    ui/wrap/slide_wrap.h
    ui/wrap/vertical_layout.cpp
    ui/wrap/vertical_layout.h
    ui/wrap/vertical_layout_reorder.cpp
    ui/wrap/vertical_layout_reorder.h
    ui/wrap/wrap.h
    ui/abstract_button.cpp
    ui/abstract_button.h
    ui/basic_click_handlers.cpp
    ui/basic_click_handlers.h
    ui/click_handler.cpp
    ui/click_handler.h
    ui/delayed_activation.cpp
    ui/delayed_activation.h
    ui/emoji_config.cpp
    ui/emoji_config.h
    ui/focus_persister.h
    ui/inactive_press.cpp
    ui/inactive_press.h
    ui/integration.cpp
    ui/integration.h
    ui/main_queue_processor.cpp
    ui/main_queue_processor.h
    ui/painter.h
    ui/ph.cpp
    ui/ph.h
    ui/rect_part.h
    ui/round_rect.cpp
    ui/round_rect.h
    ui/rp_widget.cpp
    ui/rp_widget.h
    ui/ui_utility.cpp
    ui/ui_utility.h

    ui/ui_pch.h

    emoji_suggestions/emoji_suggestions.cpp
    emoji_suggestions/emoji_suggestions.h
    emoji_suggestions/emoji_suggestions_helper.h
)

if (DESKTOP_APP_USE_PACKAGED)
    nice_target_sources(lib_ui ${src_loc} PRIVATE ui/text/qtextitemint.cpp)
else()
    nice_target_sources(lib_ui ${src_loc} PRIVATE qt_conf/linux.qrc)
endif()

if (NOT DESKTOP_APP_USE_PACKAGED_FONTS)
    nice_target_sources(lib_ui ${src_loc} PRIVATE fonts/fonts.qrc)
endif()

if (DESKTOP_APP_DISABLE_WAYLAND_INTEGRATION)
    remove_target_sources(Telegram ${src_loc} ui/platform/linux/ui_linux_wayland_integration.cpp)
    nice_target_sources(Telegram ${src_loc} PRIVATE ui/platform/linux/ui_linux_wayland_integration_dummy.cpp)
elseif(LINUX)
    target_link_libraries(lib_ui
    PUBLIC
        desktop-app::external_kwayland
    )
endif()

target_include_directories(lib_ui
PUBLIC
    ${src_loc}
    ${src_loc}/emoji_suggestions
)

target_link_libraries(lib_ui
PUBLIC
    desktop-app::lib_base
PRIVATE
    desktop-app::external_zlib
)

=== cmake/external/gsl/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(external_gsl INTERFACE IMPORTED GLOBAL)
add_library(desktop-app::external_gsl ALIAS external_gsl)

if (DESKTOP_APP_USE_PACKAGED)
    if (DESKTOP_APP_USE_PACKAGED_LAZY)
        find_package(Microsoft.GSL QUIET)
    else()
        find_package(Microsoft.GSL)
    endif()

    if (Microsoft.GSL_FOUND)
        target_link_libraries(external_gsl INTERFACE Microsoft.GSL::GSL)

        math(EXPR _gsl_version_num "${Microsoft.GSL_VERSION_MAJOR} * 10000 + ${Microsoft.GSL_VERSION_MINOR} * 100 + ${Microsoft.GSL_VERSION_PATCH}")
        target_compile_definitions(external_gsl INTERFACE GSL_VERSION=${_gsl_version_num})
    endif()
endif()

if (NOT Microsoft.GSL_FOUND)
    target_include_directories(external_gsl SYSTEM
    INTERFACE
        ${third_party_loc}/GSL/include
    )
endif()

=== cmake/external/rnnoise/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

if (DESKTOP_APP_USE_PACKAGED)
    add_library(external_rnnoise INTERFACE IMPORTED GLOBAL)
    add_library(desktop-app::external_rnnoise ALIAS external_rnnoise)

    find_package(PkgConfig REQUIRED)
    if (NOT DEFINED DESKTOP_APP_USE_RNNOISE)
        pkg_check_modules(RNNOISE IMPORTED_TARGET rnnoise)
    elseif (DESKTOP_APP_USE_RNNOISE)
        pkg_check_modules(RNNOISE REQUIRED IMPORTED_TARGET rnnoise)
    endif()
    set(DESKTOP_APP_USE_RNNOISE ${RNNOISE_FOUND} CACHE BOOL "Compile against RNNoise or not?")

    if (RNNOISE_FOUND)
        target_link_libraries(external_rnnoise INTERFACE PkgConfig::RNNOISE)
    else()
        target_compile_definitions(external_rnnoise INTERFACE USE_RNNOISE=0)
    endif()
else()
    add_library(external_rnnoise STATIC IMPORTED GLOBAL)
    add_library(desktop-app::external_rnnoise ALIAS external_rnnoise)

    set(rnnoise_lib_loc ${libs_loc}/rnnoise/out)
    if (WIN32)
        target_include_directories(external_rnnoise SYSTEM
        INTERFACE
            ${libs_loc}/rnnoise/include
        )
        set_target_properties(external_rnnoise PROPERTIES
            IMPORTED_LOCATION "${rnnoise_lib_loc}/Release/rnnoise.lib"
            IMPORTED_LOCATION_DEBUG "${rnnoise_lib_loc}/Debug/rnnoise.lib"
        )
    elseif (APPLE)
        target_include_directories(external_rnnoise SYSTEM
        INTERFACE
            ${libs_loc}/rnnoise/include
        )
        set_target_properties(external_rnnoise PROPERTIES
            IMPORTED_LOCATION "${rnnoise_lib_loc}/Release/librnnoise.a"
            IMPORTED_LOCATION_DEBUG "${rnnoise_lib_loc}/Debug/librnnoise.a"
        )
    else()
        target_include_directories(external_rnnoise SYSTEM
        INTERFACE
            /usr/local/include
        )
        find_library(RNNOISE_LIBRARY librnnoise.a)
        set_target_properties(external_rnnoise PROPERTIES
            IMPORTED_LOCATION "${RNNOISE_LIBRARY}"
        )
    endif()
endif()

## telegram-desktop 3.1.8+ds

=== Telegram/CMakeLists.txt ===
--- 
+++ 
@@ -18,6 +18,9 @@
 add_subdirectory(lib_storage)
 add_subdirectory(lib_lottie)
 add_subdirectory(lib_qr)
+if (LINUX AND NOT DESKTOP_APP_DISABLE_WAYLAND_INTEGRATION)
+    add_subdirectory(lib_waylandshells)
+endif()
 add_subdirectory(lib_webrtc)
 add_subdirectory(lib_webview)
 add_subdirectory(codegen)
@@ -39,24 +42,15 @@
 
 if (WIN32)
     include(cmake/generate_midl.cmake)
-    generate_midl(Telegram ${src_loc}/platform/win/windows_quiethours.idl)
+    generate_midl(Telegram ${src_loc}
+        platform/win/windows_quiethours.idl
+        platform/win/windows_toastactivator.idl
+    )
+
+    nuget_add_winrt(Telegram)
 endif()
 
-set_target_properties(Telegram PROPERTIES AUTOMOC ON)
-if (TDESKTOP_RESOURCES STREQUAL "Bundled")
-    set_target_properties(Telegram PROPERTIES AUTORCC ON)
-elseif (TDESKTOP_RESOURCES STREQUAL "Packed")
-    set(rcc_flags --binary "$<TARGET_PROPERTY:Telegram,AUTORCC_OPTIONS>")
-    set(qrc_files "$<FILTER:$<TARGET_PROPERTY:Telegram,SOURCES>,INCLUDE,\\.qrc$>")
-    target_compile_definitions(Telegram PRIVATE TDESKTOP_USE_PACKED_RESOURCES)
-    target_sources(Telegram PRIVATE "${CMAKE_BINARY_DIR}/tresources.rcc")
-    add_custom_command(OUTPUT "${CMAKE_BINARY_DIR}/tresources.rcc"
-        DEPENDS ${qrc_files}  # FIXME: incomplete dependencies list, missing qrc content
-        COMMAND Qt5::rcc ${rcc_flags} -o "${CMAKE_BINARY_DIR}/tresources.rcc" ${qrc_files}
-        COMMAND_EXPAND_LISTS VERBATIM
-    )
-    set_target_properties(Telegram PROPERTIES RESOURCE "${CMAKE_BINARY_DIR}/tresources.rcc")
-endif()
+set_target_properties(Telegram PROPERTIES AUTOMOC ON AUTORCC ON)
 
 target_link_libraries(Telegram
 PRIVATE
@@ -148,6 +142,8 @@
     api/api_updates.h
     api/api_user_privacy.cpp
     api/api_user_privacy.h
+    api/api_views.cpp
+    api/api_views.h
     api/api_who_read.cpp
     api/api_who_read.h
     boxes/filters/edit_filter_box.cpp
@@ -178,6 +174,8 @@
     boxes/peers/edit_peer_permissions_box.h
     boxes/about_box.cpp
     boxes/about_box.h
+    boxes/about_sponsored_box.cpp
+    boxes/about_sponsored_box.h
     boxes/abstract_box.cpp
     boxes/abstract_box.h
     boxes/add_contact_box.cpp
@@ -362,3 +360,20 @@
     core/shortcuts.h
     core/ui_integration.cpp
     core/ui_integration.h
+    core/update_checker.cpp
+    core/update_checker.h
+    core/utils.cpp
+    core/utils.h
+    core/version.h
+    countries/countries_manager.cpp
+    countries/countries_manager.h
+    data/stickers/data_stickers_set.cpp
+    data/stickers/data_stickers_set.h
+    data/stickers/data_stickers.cpp
+    data/stickers/data_stickers.h
+    data/data_abstract_sparse_ids.h
+    data/data_abstract_structure.cpp
+    data/data_abstract_structure.h
+    data/data_audio_msg_id.cpp
+    data/data_audio_msg_id.h
+    data/data_auto_download.cpp

=== cmake/linux_glib_helper/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(linux_glib_helper STATIC)
init_target(linux_glib_helper "(external)")
add_library(desktop-app::linux_glib_helper ALIAS linux_glib_helper)

nice_target_sources(linux_glib_helper ${CMAKE_CURRENT_SOURCE_DIR}
PRIVATE
    linux_glib_helper.cpp
)

target_link_libraries(linux_glib_helper
PUBLIC
    ${CMAKE_DL_LIBS}
)

find_package(PkgConfig REQUIRED)
pkg_check_modules(GLIB2 REQUIRED glib-2.0)
pkg_check_modules(GOBJECT REQUIRED gobject-2.0)

target_include_directories(linux_glib_helper SYSTEM
PRIVATE
    ${GLIB2_INCLUDE_DIRS}
    ${GOBJECT_INCLUDE_DIRS}
)

=== cmake/linux_gtk_helper/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(linux_gtk_helper STATIC)
init_target(linux_gtk_helper "(external)")
add_library(desktop-app::linux_gtk_helper ALIAS linux_gtk_helper)

nice_target_sources(linux_gtk_helper ${CMAKE_CURRENT_SOURCE_DIR}
PRIVATE
    linux_gtk_helper.cpp
)

target_link_libraries(linux_gtk_helper
PUBLIC
    ${CMAKE_DL_LIBS}
)

find_package(PkgConfig REQUIRED)
pkg_check_modules(GTK REQUIRED gtk+-3.0)
target_include_directories(linux_gtk_helper SYSTEM PRIVATE ${GTK_INCLUDE_DIRS})

=== cmake/external/kwayland/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

if (DESKTOP_APP_USE_PACKAGED)
    add_library(external_kwayland INTERFACE IMPORTED GLOBAL)
    add_library(desktop-app::external_kwayland ALIAS external_kwayland)

    find_package(KF5Wayland REQUIRED)
    target_link_libraries(external_kwayland INTERFACE KF5::WaylandClient)
else()
    add_library(external_kwayland STATIC IMPORTED GLOBAL)
    add_library(desktop-app::external_kwayland ALIAS external_kwayland)

    find_library(KWAYLAND_LIBRARY libKF5WaylandClient.a)
    set_target_properties(external_kwayland PROPERTIES
        IMPORTED_LOCATION "${KWAYLAND_LIBRARY}"
    )

    target_include_directories(external_kwayland SYSTEM
    INTERFACE
        /usr/local/include/KF5
        /usr/local/include/KF5/KWayland/Client
    )

    target_link_libraries(external_kwayland
    INTERFACE
        desktop-app::linux_wayland_helper
        $<TARGET_FILE:desktop-app::linux_wayland_helper>
        ${qt_loc}/lib/libQt5Concurrent.a
        desktop-app::external_qt
    )
endif()

=== cmake/external/qt/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(external_qt INTERFACE IMPORTED GLOBAL)
add_library(desktop-app::external_qt ALIAS external_qt)

add_subdirectory(qt_static_plugins)

if (DESKTOP_APP_USE_PACKAGED)
    target_link_libraries(external_qt
    INTERFACE
        Qt5::Core
        Qt5::Gui
        Qt5::Widgets
        Qt5::Network
        Qt5::Svg
    )

    target_include_directories(external_qt SYSTEM
    INTERFACE
        ${Qt5Core_PRIVATE_INCLUDE_DIRS}
        ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    )

    if (Qt5DBus_FOUND)
        target_link_libraries(external_qt INTERFACE Qt5::DBus)
    endif()

    if (Qt5XkbCommonSupport_FOUND)
        target_link_libraries(external_qt INTERFACE Qt5::XkbCommonSupport)

        target_include_directories(external_qt SYSTEM
        INTERFACE
            ${Qt5XkbCommonSupport_PRIVATE_INCLUDE_DIRS}
        )
    endif()

    if (Qt5WaylandClient_FOUND)
        target_link_libraries(external_qt INTERFACE Qt5::WaylandClient)

        target_include_directories(external_qt SYSTEM
        INTERFACE
            ${Qt5WaylandClient_PRIVATE_INCLUDE_DIRS}
        )
    endif()
else()
    target_include_directories(external_qt SYSTEM
    INTERFACE
        ${qt_loc}/include
        ${qt_loc}/include/QtCore
        ${qt_loc}/include/QtGui
        ${qt_loc}/include/QtWidgets
        ${qt_loc}/include/QtSvg
        ${qt_loc}/include/QtCore/${qt_version}
        ${qt_loc}/include/QtGui/${qt_version}
        ${qt_loc}/include/QtCore/${qt_version}/QtCore
        ${qt_loc}/include/QtGui/${qt_version}/QtGui
    )

    if (Qt5DBus_FOUND)
        target_include_directories(external_qt SYSTEM
        INTERFACE
            ${qt_loc}/include/QtDBus
        )
    endif()

    if (Qt5XkbCommonSupport_FOUND)
        target_include_directories(external_qt SYSTEM
        INTERFACE
            ${qt_loc}/include/QtXkbCommonSupport
            ${qt_loc}/include/QtXkbCommonSupport/${qt_version}
            ${qt_loc}/include/QtXkbCommonSupport/${qt_version}/QtXkbCommonSupport
        )
    endif()

    if (Qt5WaylandClient_FOUND)
        target_include_directories(external_qt SYSTEM
        INTERFACE
            ${qt_loc}/include/QtWaylandClient
            ${qt_loc}/include/QtWaylandClient/${qt_version}
            ${qt_loc}/include/QtWaylandClient/${qt_version}/QtWaylandClient
        )
    endif()

    target_compile_definitions(external_qt
    INTERFACE
        _REENTRANT
        QT_STATICPLUGIN
        QT_PLUGIN
        QT_WIDGETS_LIB
        QT_NETWORK_LIB
        QT_GUI_LIB
        QT_CORE_LIB
        QT_SVG_LIB
    )

    if (Qt5DBus_FOUND)
        target_compile_definitions(external_qt
        INTERFACE
            QT_DBUS_LIB
        )
    endif()

    if (Qt5XkbCommonSupport_FOUND)
        target_compile_definitions(external_qt
        INTERFACE
            QT_XKBCOMMON_SUPPORT_LIB
        )
    endif()

    if (Qt5WaylandClient_FOUND)
        target_compile_definitions(external_qt
        INTERFACE
            QT_WAYLANDCLIENT_LIB
        )
    endif()

    if (WIN32)
        set(qt_lib_prefix "")
        set(qt_lib_suffix $<$<CONFIG:Debug>:d>.lib)
    else()
        set(qt_lib_prefix lib)
        if (APPLE)
            set(qt_lib_suffix $<$<CONFIG:Debug>:_debug>.a)
        else()
            set(qt_lib_suffix .a)
        endif()
    endif()

    set(common_qt_libs
        plugins/bearer/${qt_lib_prefix}qgenericbearer
        plugins/imageformats/${qt_lib_prefix}qwebp
        plugins/imageformats/${qt_lib_prefix}qgif
        plugins/imageformats/${qt_lib_prefix}qjpeg
        lib/${qt_lib_prefix}Qt5PrintSupport
        lib/${qt_lib_prefix}Qt5AccessibilitySupport
        lib/${qt_lib_prefix}Qt5FontDatabaseSupport
        lib/${qt_lib_prefix}Qt5EventDispatcherSupport
        lib/${qt_lib_prefix}Qt5ThemeSupport
        lib/${qt_lib_prefix}Qt5Network
        lib/${qt_lib_prefix}Qt5Widgets
        lib/${qt_lib_prefix}Qt5Gui
        lib/${qt_lib_prefix}Qt5Svg
        lib/${qt_lib_prefix}qtharfbuzz
        lib/${qt_lib_prefix}qtlibpng
    )

    set(qt_libs_list "")
    if (WIN32)
        set(qt_libs
            ${common_qt_libs}
            lib/${qt_lib_prefix}Qt5Core
            lib/${qt_lib_prefix}Qt5WindowsUIAutomationSupport
            lib/${qt_lib_prefix}qtmain
            lib/${qt_lib_prefix}qtfreetype
            lib/${qt_lib_prefix}qtpcre2
            plugins/platforms/${qt_lib_prefix}qwindows
        )
        foreach (lib ${qt_libs})
            list(APPEND qt_libs_list "${qt_loc}/${lib}${qt_lib_suffix}")
        endforeach()

        target_link_libraries(external_qt
        INTERFACE
            desktop-app::external_angle
        )
    elseif (APPLE)
        set(qt_libs
            ${common_qt_libs}
            lib/${qt_lib_prefix}Qt5Core
            lib/${qt_lib_prefix}Qt5GraphicsSupport
            lib/${qt_lib_prefix}Qt5ClipboardSupport
            lib/${qt_lib_prefix}qtfreetype
            lib/${qt_lib_prefix}qtpcre2
            plugins/platforms/${qt_lib_prefix}qcocoa
        )
        foreach (lib ${qt_libs})
            list(APPEND qt_libs_list "${qt_loc}/${lib}${qt_lib_suffix}")
        endforeach()
        target_link_libraries(external_qt
        INTERFACE
            cups
        )
    else()
        set(qt_libs_dbus)
        set(qt_libs_dbus_support)
        set(qt_libs_dbus_plugins)
        set(qt_libs_dbus_bearers)
        if (Qt5DBus_FOUND)
            set(qt_libs_dbus lib/${qt_lib_prefix}Qt5DBus)
            set(qt_libs_dbus_support lib/${qt_lib_prefix}Qt5LinuxAccessibilitySupport)
            set(qt_libs_dbus_plugins
                plugins/platforminputcontexts/${qt_lib_prefix}ibusplatforminputcontextplugin
            )
            set(qt_libs_dbus_bearers
                plugins/bearer/${qt_lib_prefix}qconnmanbearer
                plugins/bearer/${qt_lib_prefix}qnmbearer
            )
        endif()
        set(qt_libs_waylandclient)
        set(qt_libs_waylandclient_plugins)
        if (Qt5WaylandClient_FOUND)
            set(qt_libs_waylandclient lib/${qt_lib_prefix}Qt5WaylandClient)
            set(qt_libs_waylandclient_plugins
                plugins/platforms/${qt_lib_prefix}qwayland-generic
                plugins/platforms/${qt_lib_prefix}qwayland-egl
                plugins/wayland-graphics-integration-client/${qt_lib_prefix}qt-plugin-wayland-egl
                plugins/wayland-shell-integration/${qt_lib_prefix}wl-shell
                plugins/wayland-decoration-client/${qt_lib_prefix}bradient
            )
        endif()
        set(qt_libs
            plugins/platforminputcontexts/${qt_lib_prefix}composeplatforminputcontextplugin
            ${qt_libs_dbus_plugins}
            ${qt_libs_waylandclient_plugins}
            plugins/platformthemes/${qt_lib_prefix}qgtk3
            plugins/platforms/${qt_lib_prefix}qxcb
            plugins/xcbglintegrations/${qt_lib_prefix}qxcb-egl-integration
            plugins/xcbglintegrations/${qt_lib_prefix}qxcb-glx-integration
            plugins/iconengines/${qt_lib_prefix}qsvgicon
            lib/${qt_lib_prefix}Qt5XcbQpa
            lib/${qt_lib_prefix}Qt5EglSupport
            lib/${qt_lib_prefix}Qt5GlxSupport
            lib/${qt_lib_prefix}Qt5ServiceSupport
            lib/${qt_lib_prefix}Qt5EdidSupport
            lib/${qt_lib_prefix}Qt5XkbCommonSupport
            ${qt_libs_dbus_support}
            ${qt_libs_dbus_bearers}
            ${qt_libs_waylandclient}
            lib/${qt_lib_prefix}Qt5ServiceSupport
            ${common_qt_libs}
            ${qt_libs_dbus}
            lib/${qt_lib_prefix}Qt5Core
            lib/${qt_lib_prefix}qtpcre2
        )
        foreach (lib ${qt_libs})
            list(APPEND qt_libs_list "${qt_loc}/${lib}${qt_lib_suffix}")
        endforeach()
    endif()

    target_link_libraries(external_qt
    INTERFACE
        ${qt_libs_list}
        $<TARGET_FILE:desktop-app::external_openssl_ssl>
        $<TARGET_FILE:desktop-app::external_openssl_crypto>
        desktop-app::external_jpeg
        desktop-app::external_zlib
    )

    if (LINUX)
        target_include_directories(external_qt SYSTEM
        INTERFACE
            ${qt_loc}/mkspecs/linux-g++
        )
        target_link_static_libraries(external_qt
        INTERFACE
            proxy
            epoxy
            xkbcommon
            xkbcommon-x11
            xcb-glx
            xcb-xkb
            xcb-randr
            xcb-icccm
            xcb-shm
            xcb-render
            xcb-image
            xcb-xfixes
            xcb-xinerama
            xcb-xinput
            xcb-shape
            xcb-sync
            xcb-util
            xcb-render-util
            xcb-keysyms
            z
        )
        if (Qt5WaylandClient_FOUND)
            target_link_libraries(external_qt
            INTERFACE
                desktop-app::linux_wayland_helper
                $<TARGET_FILE:desktop-app::linux_wayland_helper>
            )
        endif()
        target_link_libraries(external_qt
        INTERFACE
            desktop-app::linux_gtk_helper
            $<TARGET_FILE:desktop-app::linux_gtk_helper>
            desktop-app::linux_glib_helper
            $<TARGET_FILE:desktop-app::linux_glib_helper>
            fontconfig
            freetype
            xcb
            X11
            X11-xcb
            ${CMAKE_DL_LIBS}
            pthread
        )
    endif()
endif()

=== debian/changelog ===
telegram-desktop (3.1.8+ds-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 11 Dec 2021 15:21:26 -0800

telegram-desktop (3.1.8+ds-1) unstable; urgency=medium

  * New upstream release.
  * Update patches.
  * Strip -ffat-lto-objects compiler flag.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sun, 17 Oct 2021 21:37:39 +0300

=== debian/control ===
Source: telegram-desktop
Section: net
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
Build-Depends: debhelper-compat (=12)
Build-Depends-Arch: cmake (>=3.16.0),
                    libasound2-dev,
                    libavcodec-dev (>=7:3.2),
                    libavformat-dev (>=7:3.2),
                    libavutil-dev (>=7:3.2),
                    libdbusmenu-qt5-dev,
                    libexpected-dev,
                    libglib2.0-dev,
                    libglibmm-2.4-dev,
                    libgtk-3-dev,
                    libhunspell-dev,
                    libjemalloc-dev,
                    libkf5wayland-dev [linux-any],
                    liblz4-dev,
                    liblzma-dev,
                    libminizip-dev (>=1.1),
                    libmsgsl-dev (>=1.0.0),
                    libopenal-dev,
                    libopus-dev (>=1.1),
                    libpulse-dev,
                    libqrcodegencpp-dev,
                    libqt5svg5-dev,
                    libqt5waylandclient5-dev [linux-any],
                    librange-v3-dev (>=0.10.0),
                    librlottie-dev,
                    libssl-dev (>=1.0.1),
                    libswresample-dev (>=7:3.2),
                    libswscale-dev (>=7:3.2),
                    libtgowt-dev (>=0~git20210627~),
                    libwebkit2gtk-4.0-dev,
                    libxcb-keysyms1-dev,
                    libxcb-record0-dev,
                    libxcb-screensaver0-dev,
                    libxcb1-dev,
                    libxxhash-dev,
                    python3:any,
                    qtbase5-dev (>=5.11.3),
                    qtbase5-private-dev (>=5.11.3),
                    qtwayland5-private-dev [linux-any],
                    zlib1g-dev (>=1:1.2.8)
Build-Conflicts-Arch: libtgvoip-dev
Standards-Version: 4.6.0
Rules-Requires-Root: no
Homepage: https://desktop.telegram.org
Vcs-Git: https://salsa.debian.org/debian/telegram-desktop.git
Vcs-Browser: https://salsa.debian.org/debian/telegram-desktop

Package: telegram-desktop
Architecture: amd64 arm64 armel armhf hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 mips64el mipsel ppc64el riscv64 sh4 x32
Depends: qt5-image-formats-plugins (>=5.9.0),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: fonts-open-sans
Built-Using: ${cpplibs:Built-Using}
Description: fast and secure messaging application
 Telegram is a messaging app with a focus on speed and security, it is
 super-fast, simple and free. You can use Telegram on all your devices at the
 same time — your messages sync seamlessly across any number of your phones,
 tablets or computers.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
include /usr/share/dpkg/default.mk

EXTRA_CMAKE_VARIABLES += \
	TDESKTOP_API_ID=50322 \
	TDESKTOP_API_HASH=9ff1a639196c0779c86dd661af8522ba \
	TDESKTOP_RESOURCES=Packed \
	DESKTOP_APP_REQUIRE_JEMALLOC=OFF \
	CMAKE_SKIP_INSTALL_ALL_DEPENDENCY=ON \
	CMAKE_STATIC_LINKER_FLAGS='-T'

DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Reveal any errors with pre-compiled headers.
DEB_CPPFLAGS_MAINT_APPEND += -Werror=invalid-pch

# Print full stack trace of template instantiations.
DEB_CXXFLAGS_MAINT_APPEND += -ftemplate-backtrace-limit=0

# Build scripts do not require compiled object code. This also shrinks result
# binary by 50 kB.
DEB_CXXFLAGS_MAINT_STRIP += -ffat-lto-objects

ifeq ($(filter terse,$(DEB_BUILD_OPTIONS)),)
 # Print entire arguments of moc invocation.
 EXTRA_CMAKE_VARIABLES += CMAKE_AUTOGEN_VERBOSE=ON
endif

ifeq ($(filter noopt,$(DEB_BUILD_OPTIONS)),)
 # Hide warnings useless for final build.
 DEB_CXXFLAGS_MAINT_APPEND += -Wno-deprecated-declarations
endif

ifneq ($(DEB_HOST_ARCH_OS),linux)
 # Wayland is not ready on GNU/Hurd or Debian/kFreeBSD.
 # Make sure KWayland library and Qt WaylandClient plugin are not in use.
 EXTRA_CMAKE_VARIABLES += DESKTOP_APP_DISABLE_WAYLAND_INTEGRATION=ON
 DEB_CPPFLAGS_MAINT_APPEND += -UQT_WAYLANDCLIENT_LIB
endif

ifeq ($(filter pkg.$(DEB_SOURCE).lotmem,$(DEB_BUILD_PROFILES)),)
 ifeq ($(DEB_BUILD_ARCH_BITS),32)
  ATTEMPT_SAVE_MEMORY = 1
 endif
 ifneq ($(filter Debian-riscv64 Ubuntu-arm64 Ubuntu-ppc64el,$(DEB_VENDOR)-$(DEB_BUILD_ARCH)),)
  ATTEMPT_SAVE_MEMORY = 1
 endif
endif
ifdef ATTEMPT_SAVE_MEMORY
 # Less debug info by default to fit small address space.
 ifneq ($(filter -g,$(CXXFLAGS)),)
  DEB_CXXFLAGS_MAINT_STRIP += -g
  DEB_CXXFLAGS_MAINT_PREPEND += -g1
 endif
 # Attempt to reduce RAM consumption even more.
 DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-keep-memory
endif

CPPLIBS_PACKAGES = libexpected-dev libmsgsl-dev librange-v3-dev libtgowt-dev
EXTRA_SUBSTVARS += \
	cpplibs:Built-Using=$(shell dpkg-query -Wf '$${source:Package}(=$${Version}),' $(CPPLIBS_PACKAGES))

# Make visible all possible maintainer's flags.
export DEB_BUILD_MAINT_OPTIONS $(foreach flag,$(DPKG_BUILDFLAGS_LIST),\
	$(foreach operation,STRIP APPEND PREPEND,DEB_$(flag)_MAINT_$(operation)))

# Make debugging a little easier. https://stackoverflow.com/a/25817631/5000805
# Print also export line if the variable is being exported.
print-%:
	@echo $* = $($*)
	@env | sed '/^\($*\)=.*/s//export \1/;t;d'

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(EXTRA_CMAKE_VARIABLES:%=-D%)

override_dh_installchangelogs:
	dh_installchangelogs changelog.txt

# Maximize the limit of debug information entries and ignore possible overflow errors.
override_dh_dwz:
	-dh_dwz -- -L 2147483647

override_dh_gencontrol:
	dh_gencontrol -- $(EXTRA_SUBSTVARS:%="-V%")

# MX don't need no stinkin' dbgsyms
override_dh_strip:
	dh_strip --no-automatic-dbgsym
